/* ---------------------------------------------------------- */
/*  BasicSystem.h                                             */
/* ---------------------------------------------------------- */

/*------------------------------------------------------------- */
/** @file
    @brief		Luna system ̉Bƒۉ
    @author		K.Kunikane (끗ӂ)
    @since		Feb.12.2005
    $Revision: 1.1.1.1 $
*/
/*-----------------------------------------------------
 Copyright (C) 2005 rero2@fumi <rero2@yuumu.org>
 All Rights Reserved.
 ------------------------------------------------------*/

#ifndef BASICSYSTEM_H
#define BASICSYSTEM_H

/*-------------------------------*/
/* include                       */
/*-------------------------------*/

#include "luna.h"

#include "lunavader.h"

/*-------------------------------*/
/* define                        */
/*-------------------------------*/

//! fobObZ[Wێ̂߂̍sz
#define DEBUGMESSAGELIST   64

//! vC[͂̃rbg
#define  BS_INPUT_UP       (1)
#define  BS_INPUT_DOWN     (1 << 1)
#define  BS_INPUT_LEFT     (1 << 2)
#define  BS_INPUT_RIGHT    (1 << 3)
#define  BS_INPUT_BUTTON1  (1 << 8)
#define  BS_INPUT_BUTTON2  (1 << 9)
#define  BS_INPUT_BUTTON3  (1 << 10)
#define  BS_INPUT_BUTTON4  (1 << 11)

//! TEht@C̐
#define  BS_SOUND_MAX  13
//! ~[WbNt@C̐
#define  BS_MUSIC_MAX  1

//! @\p̃XvCgobt@̃TCY
#define  BS_SPBUF_MYSHIP  1
//! e\p̃XvCgobt@̃TCY
#define  BS_SPBUF_MYSHOT  1
//! GQ̕\p̃XvCgobt@̃TCY
#define  BS_SPBUF_ENEMY   50
//! {[iXD\p̃XvCgobt@̃TCY
#define  BS_SPBUF_BONUSSHIP  1
//! GeGtFNg̃XvCgobt@̃TCY
#define  BS_SPBUF_BULLET  5000
//! wi\p̃XvCgobt@̃TCY
#define  BS_SPBUF_BACKGROUND  10
//! XRApl\p̃XvCgobt@̃TCY
#define  BS_SPBUF_PANEL  100
//! ^Cgʕ\p̃XvCgobt@̃TCY
#define  BS_SPBUF_TITLE  50

//! @\p̃XvCg[x
#define  BS_DEPTH_MYSHIP  10
//! e\p̃XvCg[x
#define  BS_DEPTH_MYSHOT  8
//! GQ̕\p̃XvCg[x
#define  BS_DEPTH_ENEMY   15
//! {[iXD\p̃XvCg[x
#define  BS_DEPTH_BONUSSHIP  15
//! GeGtFNg̃XvCg[x
#define  BS_DEPTH_BULLET  5
//! wi\p̃XvCg[x
#define  BS_DEPTH_BACKGROUND  100
//! XRApl\p̃XvCg[x
#define  BS_DEPTH_PANEL  5
//! XRApl̕\p̃XvCg[x
#define  BS_DEPTH_PANELITEM  6
//! ^Cgʕ\p̃XvCg[x
#define  BS_DEPTH_TITLE  50



/*-------------------------------*/
/* struct                        */
/*-------------------------------*/

/*-------------------------------*/
/* class                         */
/*-------------------------------*/

/**
 * @brief DirectX system Rg[NX
 *        Luna Cuւ̃ANZX̑唼̒ōs
 *        ł邾 DirectX  Luna Ȃlɂ܂B
 *        SpriteItem NXȊO Luna G炸ɍςނƂ̂ڕWB
 *
 * @todo -
 * @bug -
 */
class BasicSystem
{
  /* ----------------------------------- */
  /* --- RXgN^EfXgN^ */
 public:
  BasicSystem();
  virtual  ~BasicSystem();

  /* ----------------------------------- */
  /* --- pubNo */
 public:
  //! Q[XRA
  long  m_Score;
  //! Q[nCXRA
  long  m_HighScore;

  /* ----------------------------------- */
  /* --- vCx[go */
 private:
  //! vC[rbgŕێ
  unsigned long  m_PlayerInput;
  //! vC[̃vbVgK[rbgŕێ
  unsigned long  m_PlayerInputTriger;
  //! BGM tǂ
  bool  m_IsMusicPlaying;
  //! t BGM ԍ
  int  m_PlayingMusic;
  //! @\p̃XvCgobt@
  LSPRITE  m_SpriteMyShip;
  //! e\p̃XvCgobt@
  LSPRITE  m_SpriteMyShot;
  //! GQ̕\p̃XvCgobt@
  LSPRITE  m_SpriteEnemy;
  //! {[iXD\p̃XvCgobt@
  LSPRITE  m_SpriteBonus;
  //! GeGtFNg̃XvCgobt@
  LSPRITE  m_SpriteBullet;
  //! wi\p̃XvCgobt@
  LSPRITE  m_SpriteBack;
  //! XRApl\p̃XvCgobt@
  LSPRITE  m_SpritePanel;
  //! ^Cgʕ\p̃XvCgobt@
  LSPRITE  m_SpriteTitle;
  //! eNX`nh
  LTEXTURE  m_TextureMyShip;
  LTEXTURE  m_TextureEnemy;
  LTEXTURE  m_TextureBonus;
  LTEXTURE  m_TextureBullet;
  LTEXTURE  m_TextureBack;
  LTEXTURE  m_TexturePanel;
  LTEXTURE  m_TextureTitle;
  //! fobOfBXvCpێ
  unsigned char*  m_DebugMessage[DEBUGMESSAGELIST];
  //! TEhnh
  LSOUND  m_Sound[BS_SOUND_MAX];
  //! ~[WbNnh
  LSOUND  m_Music[BS_MUSIC_MAX];

  /* ----------------------------------- */
  /* --- pubN\bh */
 public:
  void Init();
  void Release();
  void Tick();
  void DisplayUpdate();
  unsigned long GetKeyInput();
  unsigned long GetKeyInputTriger();
  LSPRITE GetBulletSprite();
  LSPRITE GetMyShipSprite();
  LSPRITE GetMyShotSprite();
  LSPRITE GetEnemySprite();
  LSPRITE GetBonusShipSprite();
  LSPRITE GetPanelSprite();
  LSPRITE GetTitleSprite();
  LSPRITE GetBackGroundSprite();
  void PlaySoundEffect(int num);
  void PlayMusic(int num);
  void StopMusic();
  void AddDebugMessage(unsigned char *line);


  /* ----------------------------------- */
  /* --- vCx[g\bh */
 private:
  void  display_debug_strings();
  void  read_pad();

};


#endif

