//=============================================================================
//         Luna for DiretX9
//=============================================================================
//
//		{vWFNgTv
//
//=============================================================================


//=============================================================================
// INCLUDE
//=============================================================================
#include "Luna.h"

#include "basicsystem.h"
#include "gamedirector.h"
#include "lunavader.h"

//=============================================================================
// DEFINE
//=============================================================================

// Ƃ肠 64MB 炢
#define WORK_MEMORY_SIZE    (64 * 1024 * 1024)

#define SCREEN_WIDTH        (640)
#define SCREEN_HEIGHT       (480)
#define FRAME_RATE          (60)


//=============================================================================
//		bZ[Wp֐
//=============================================================================
//	bZ[W̏s֐ł
//=============================================================================
// input
//
// return
//
//=============================================================================
bool Luna::MessageProc( long Msg, long wParam, long lParam )
{
  switch ( Msg )
    {
      // L[Cxg
    case WM_KEYDOWN:
      switch ( wParam )
	{
	  // GXP[vL[
	case VK_ESCAPE:
	  // I
	  Luna::Exit();
	  break;
	  // F1L[
	case VK_F1:
	  // ʐ؂ւ
	  Luna::ChangeScreenMode();
	  break;
	}
      break;
    }

  return true;
}


//=============================================================================
//		AvP[Vݒ
//=============================================================================
//	AvP[V̏ݒs߂̊֐ł
//=============================================================================
// input
//
// return
//
//=============================================================================
bool Luna::Init( void )
{
  //--------------------------------------------------------
  // [Npݒ
  //	MemoryAlloc()AMemoryClearAlloc()AMemoryFree()֐
  //	gp郁̈̃TCYw肵܂B
  //	Ŏw肵̈悩烁mۂ܂̂ŁA
  //	ۂɃAvP[VŎgpĂ郁̑ʂ
  //	c胁[Ñ`FbNȂǂs܂B
  //
  //	܂AŌ̈fobO[ĥnm^neełB
  //  truew肷邱ƂŊmۃȏ̃ANZX
  //	oAIɉYĂ郁̈
  //	邱Ƃł܂B
  //	G[NĂ郁̈̊mۃt@CƂ
  //	so͂܂B
  //
  //	̌ʂ̓Oɏo͂܂̂ŁA
  //	J̓fobOnmAOo͂nmɂĂƂ
  //	D܂Ǝv܂B
  //--------------------------------------------------------
  Luna::SetWorkMemory( WORK_MEMORY_SIZE, true );

  //--------------------------------------------------------
  // AvP[V
  //--------------------------------------------------------
  Luna::SetApplicationName( "ŖGxt - udonge" );

  //--------------------------------------------------------
  // ʏݒ
  //--------------------------------------------------------
  Luna::SetScreenInfo( SCREEN_WIDTH, SCREEN_HEIGHT, true );

#if DEBUG
  //--------------------------------------------------------
  // o̓O
  //--------------------------------------------------------
  Luna::SetLogFileName( "lunadebug" );

  //--------------------------------------------------------
  // AvP[Ṽ^Cgo[ɏ\
  //--------------------------------------------------------
  Luna::SetDrawTitleInfo();

  //--------------------------------------------------------
  // NOEBhEɏo
  //--------------------------------------------------------
  Luna::SetBootLogUse( true );
#endif

  //--------------------------------------------------------
  // gpIvVݒ
  //--------------------------------------------------------
  Luna::SetUseOption(OPTION_DIRECT3D |
		     OPTION_DIRECTINPUT |
		     OPTION_DIRECTSOUND |
		     OPTION_DIRECTMUSIC);

  //--------------------------------------------------------
  // gpt@CEfBNgf[^o^
  //--------------------------------------------------------

  /* --- [g̃fBNgpbNt@Cݒ */
  LunaFile::SetRootPath( ".", "" );
  /* --- LunaSurface, LunaTexture, LunaSheet QƐ */
  LunaFile::SetDataPath( PATH_TYPE_TEXTURE, "texture" );
  /* --- LunaSound QƐ */
  LunaFile::SetDataPath( PATH_TYPE_SOUND, "sound" );
  LunaFile::SetDataPath( PATH_TYPE_MUSIC, "sound" );

  /* ȉ̓ftHg̐ݒpX
     LunaFile::SetDataPath( PATH_TYPE_MODEL, "model" );		// LunaModel, LunaModelEx QƐ
     LunaFile::SetDataPath( PATH_TYPE_SHADER, "shader" );	// LunaShaderEffect QƐ
     LunaFile::SetDataPath( PATH_TYPE_FONT, "font" );		// LunaFontSprite, LunaFontSprite3D QƐ
     LunaFile::SetDataPath( PATH_TYPE_AUDIO, "audio" );		// LunaMedia QƐ
     LunaFile::SetDataPath( PATH_TYPE_MEDIA, "media" );		// LunaMedia QƐ
     LunaFile::SetDataPath( PATH_TYPE_DATA, "data" );		// [U[`̃f[^i[
  */

  return true;
}


//=============================================================================
//		C[v
//=============================================================================
//	R\[AvP[VŕW main ֐Ɠ̂łB
//=============================================================================
// input
//		long ArgNum		: ̐iŒP
//		char *pArgStr[]	: ̕iŏEXE
//
// return
//
//=============================================================================
void Luna::Main( long ArgNum, char *pArgStr[] )
{
  /* --- Q[NX */
  BasicSystem  luna_system;
  GameDirector  lunavader_main;

  //--------------------------------------------------------
  // SVXe̊Jn
  //--------------------------------------------------------
  if ( Luna::Start() )
    {
      //-----------------------------------------------
      // 
      //
      //	Ɋe평Lq܂B
      //-----------------------------------------------

      luna_system.Init();
      lunavader_main.SetBasicSystem(&luna_system);
      lunavader_main.Init();

      //-----------------------------------------------
      // Q[p[v
      //
      //	WindowsAvP[Vł while ( 1 ) Ȃǂ̕
      //	@Ń[vĂ͂Ȃ̂ WaitForMsgLoop()
      //	֐ŃEBhEbZ[WŏĂ܂B
      //-----------------------------------------------
      while ( Luna::WaitForMsgLoop() )
	{
	  // t[[g
	  Luna::SyncFrame( FRAME_RATE );

	  // ʍXV
	  //	obNobt@̓eEBhEɓ]܂B
	  Luna3D::Refresh();

	  // ʃNA
	  Luna3D::Clear( D3DCLEAR_TARGET, D3DCOLOR_XRGB(0, 0, 128) );

	  /* -------------------------------- */
	  /* --- Q[{̃CXebv */
	  luna_system.Tick();
	  if (lunavader_main.Tick() == false) {
	    break;
	  }
	  luna_system.DisplayUpdate();
	}

      //--------------------------------------------------------
      // I
      //
      //	ɊeILq܂B
      //-------------------------------------------------------- 
      luna_system.Release();
    }

  //--------------------------------------------------------
  // SVXȅI
  //--------------------------------------------------------
  Luna::End();
}


